Index: protocols/purple/purple.c
===================================================================
--- protocols/purple/purple.c	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/purple/purple.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -23,4 +23,5 @@
 
 #include "bitlbee.h"
+#include "bpurple.h"
 #include "help.h"
 
@@ -39,10 +40,26 @@
 static char *set_eval_display_name(set_t *set, char *value);
 
+void purple_request_input_callback(guint id, struct im_connection *ic,
+                                   const char *message, const char *who);
+
+/* purple_request_input specific stuff */
+typedef void (*ri_callback_t)(gpointer, const gchar *);
+
+struct request_input_data {
+	ri_callback_t data_callback;
+	void *user_data;
+	struct im_connection *ic;
+	char *buddy;
+	guint id;
+};
+
 struct im_connection *purple_ic_by_pa(PurpleAccount *pa)
 {
 	GSList *i;
+	struct purple_data *pd;
 
 	for (i = purple_connections; i; i = i->next) {
-		if (((struct im_connection *) i->data)->proto_data == pa) {
+		pd = ((struct im_connection *) i->data)->proto_data;
+		if (pd->account == pa) {
 			return i->data;
 		}
@@ -290,5 +307,5 @@
 {
 	struct im_connection *ic = imcb_new(acc);
-	PurpleAccount *pa;
+	struct purple_data *pd;
 
 	if ((local_bee != NULL && local_bee != acc->bee) ||
@@ -306,18 +323,28 @@
 	purple_connections = g_slist_prepend(purple_connections, ic);
 
-	ic->proto_data = pa = purple_account_new(acc->user, (char *) acc->prpl->data);
-	purple_account_set_password(pa, acc->pass);
-	purple_sync_settings(acc, pa);
-
-	purple_account_set_enabled(pa, "BitlBee", TRUE);
+	ic->proto_data = pd = g_new0(struct purple_data, 1);
+	pd->account = purple_account_new(acc->user, (char *) acc->prpl->data);
+	pd->input_requests = g_hash_table_new_full(g_direct_hash, g_direct_equal,
+	                                           NULL, g_free);
+	pd->next_request_id = 0;
+	purple_account_set_password(pd->account, acc->pass);
+	purple_sync_settings(acc, pd->account);
+
+	purple_account_set_enabled(pd->account, "BitlBee", TRUE);
 }
 
 static void purple_logout(struct im_connection *ic)
 {
-	PurpleAccount *pa = ic->proto_data;
-
-	purple_account_set_enabled(pa, "BitlBee", FALSE);
+	struct purple_data *pd = ic->proto_data;
+
+	if (!pd) {
+		return;
+	}
+
+	purple_account_set_enabled(pd->account, "BitlBee", FALSE);
 	purple_connections = g_slist_remove(purple_connections, ic);
-	purple_accounts_remove(pa);
+	purple_accounts_remove(pd->account);
+	g_hash_table_destroy(pd->input_requests);
+	g_free(pd);
 }
 
@@ -325,9 +352,16 @@
 {
 	PurpleConversation *conv;
+	struct purple_data *pd = ic->proto_data;
+
+	if (!strncmp(who, PURPLE_REQUEST_HANDLE, sizeof(PURPLE_REQUEST_HANDLE) - 1)) {
+		guint request_id = atoi(who + sizeof(PURPLE_REQUEST_HANDLE));
+		purple_request_input_callback(request_id, ic, message, who);
+		return 1;
+	}
 
 	if ((conv = purple_find_conversation_with_account(PURPLE_CONV_TYPE_IM,
-	                                                  who, ic->proto_data)) == NULL) {
+	                                                  who, pd->account)) == NULL) {
 		conv = purple_conversation_new(PURPLE_CONV_TYPE_IM,
-		                               ic->proto_data, who);
+		                               pd->account, who);
 	}
 
@@ -339,8 +373,8 @@
 static GList *purple_away_states(struct im_connection *ic)
 {
-	PurpleAccount *pa = ic->proto_data;
+	struct purple_data *pd = ic->proto_data;
 	GList *st, *ret = NULL;
 
-	for (st = purple_account_get_status_types(pa); st; st = st->next) {
+	for (st = purple_account_get_status_types(pd->account); st; st = st->next) {
 		PurpleStatusPrimitive prim = purple_status_type_get_primitive(st->data);
 		if (prim != PURPLE_STATUS_AVAILABLE && prim != PURPLE_STATUS_OFFLINE) {
@@ -354,6 +388,6 @@
 static void purple_set_away(struct im_connection *ic, char *state_txt, char *message)
 {
-	PurpleAccount *pa = ic->proto_data;
-	GList *status_types = purple_account_get_status_types(pa), *st;
+	struct purple_data *pd = ic->proto_data;
+	GList *status_types = purple_account_get_status_types(pd->account), *st;
 	PurpleStatusType *pst = NULL;
 	GList *args = NULL;
@@ -378,5 +412,6 @@
 	}
 
-	purple_account_set_status_list(pa, st ? purple_status_type_get_id(pst) : "away",
+	purple_account_set_status_list(pd->account,
+	                               st ? purple_status_type_get_id(pst) : "away",
 	                               TRUE, args);
 
@@ -447,4 +482,5 @@
 	PurpleBuddy *pb;
 	PurpleGroup *pg = NULL;
+	struct purple_data *pd = ic->proto_data;
 
 	if (group && !(pg = purple_find_group(group))) {
@@ -453,9 +489,9 @@
 	}
 
-	pb = purple_buddy_new((PurpleAccount *) ic->proto_data, who, NULL);
+	pb = purple_buddy_new(pd->account, who, NULL);
 	purple_blist_add_buddy(pb, NULL, pg, NULL);
-	purple_account_add_buddy((PurpleAccount *) ic->proto_data, pb);
-
-	purple_gg_buddylist_export(((PurpleAccount *) ic->proto_data)->gc);
+	purple_account_add_buddy(pd->account, pb);
+
+	purple_gg_buddylist_export(pd->account->gc);
 }
 
@@ -463,49 +499,52 @@
 {
 	PurpleBuddy *pb;
-
-	pb = purple_find_buddy((PurpleAccount *) ic->proto_data, who);
+	struct purple_data *pd = ic->proto_data;
+
+	pb = purple_find_buddy(pd->account, who);
 	if (pb != NULL) {
 		PurpleGroup *group;
 
 		group = purple_buddy_get_group(pb);
-		purple_account_remove_buddy((PurpleAccount *) ic->proto_data, pb, group);
+		purple_account_remove_buddy(pd->account, pb, group);
 
 		purple_blist_remove_buddy(pb);
 	}
 
-	purple_gg_buddylist_export(((PurpleAccount *) ic->proto_data)->gc);
+	purple_gg_buddylist_export(pd->account->gc);
 }
 
 static void purple_add_permit(struct im_connection *ic, char *who)
 {
-	PurpleAccount *pa = ic->proto_data;
-
-	purple_privacy_permit_add(pa, who, FALSE);
+	struct purple_data *pd = ic->proto_data;
+
+	purple_privacy_permit_add(pd->account, who, FALSE);
 }
 
 static void purple_add_deny(struct im_connection *ic, char *who)
 {
-	PurpleAccount *pa = ic->proto_data;
-
-	purple_privacy_deny_add(pa, who, FALSE);
+	struct purple_data *pd = ic->proto_data;
+
+	purple_privacy_deny_add(pd->account, who, FALSE);
 }
 
 static void purple_rem_permit(struct im_connection *ic, char *who)
 {
-	PurpleAccount *pa = ic->proto_data;
-
-	purple_privacy_permit_remove(pa, who, FALSE);
+	struct purple_data *pd = ic->proto_data;
+
+	purple_privacy_permit_remove(pd->account, who, FALSE);
 }
 
 static void purple_rem_deny(struct im_connection *ic, char *who)
 {
-	PurpleAccount *pa = ic->proto_data;
-
-	purple_privacy_deny_remove(pa, who, FALSE);
+	struct purple_data *pd = ic->proto_data;
+
+	purple_privacy_deny_remove(pd->account, who, FALSE);
 }
 
 static void purple_get_info(struct im_connection *ic, char *who)
 {
-	serv_get_info(purple_account_get_connection(ic->proto_data), who);
+	struct purple_data *pd = ic->proto_data;
+
+	serv_get_info(purple_account_get_connection(pd->account), who);
 }
 
@@ -517,5 +556,5 @@
 {
 	PurpleTypingState state = PURPLE_NOT_TYPING;
-	PurpleAccount *pa = ic->proto_data;
+	struct purple_data *pd = ic->proto_data;
 
 	if (flags & OPT_TYPING) {
@@ -525,5 +564,5 @@
 	}
 
-	serv_send_typing(purple_account_get_connection(pa), who, state);
+	serv_send_typing(purple_account_get_connection(pd->account), who, state);
 
 	return 1;
@@ -559,8 +598,8 @@
 	/* There went my nice afternoon. :-( */
 
-	PurpleAccount *pa = ic->proto_data;
-	PurplePlugin *prpl = purple_plugins_find_with_id(pa->protocol_id);
+	struct purple_data *pd = ic->proto_data;
+	PurplePlugin *prpl = purple_plugins_find_with_id(pd->account->protocol_id);
 	PurplePluginProtocolInfo *pi = prpl->info->extra_info;
-	PurpleBuddy *pb = purple_find_buddy((PurpleAccount *) ic->proto_data, who);
+	PurpleBuddy *pb = purple_find_buddy(pd->account, who);
 	PurpleMenuAction *mi;
 	GList *menu;
@@ -597,6 +636,7 @@
 	PurpleConversation *pc = gc->data;
 	PurpleConvChat *pcc = PURPLE_CONV_CHAT(pc);
-
-	serv_chat_invite(purple_account_get_connection(gc->ic->proto_data),
+	struct purple_data *pd = gc->ic->proto_data;
+
+	serv_chat_invite(purple_account_get_connection(pd->account),
 	                 purple_conv_chat_get_id(pcc),
 	                 message && *message ? message : "Please join my chat",
@@ -623,6 +663,6 @@
                                    set_t **sets)
 {
-	PurpleAccount *pa = ic->proto_data;
-	PurplePlugin *prpl = purple_plugins_find_with_id(pa->protocol_id);
+	struct purple_data *pd = ic->proto_data;
+	PurplePlugin *prpl = purple_plugins_find_with_id(pd->account->protocol_id);
 	PurplePluginProtocolInfo *pi = prpl->info->extra_info;
 	GHashTable *chat_hash;
@@ -631,14 +671,17 @@
 
 	if (!pi->chat_info || !pi->chat_info_defaults ||
-	    !(info = pi->chat_info(purple_account_get_connection(pa)))) {
+	    !(info = pi->chat_info(purple_account_get_connection(pd->account)))) {
 		imcb_error(ic, "Joining chatrooms not supported by this protocol");
 		return NULL;
 	}
 
-	if ((conv = purple_find_conversation_with_account(PURPLE_CONV_TYPE_CHAT, room, pa))) {
+	if ((conv = purple_find_conversation_with_account(PURPLE_CONV_TYPE_CHAT,
+	                                                  room, pd->account))) {
 		purple_conversation_destroy(conv);
 	}
 
-	chat_hash = pi->chat_info_defaults(purple_account_get_connection(pa), room);
+	chat_hash = pi->chat_info_defaults(
+	        purple_account_get_connection(pd->account), room
+	);
 
 	for (l = info; l; l = l->next) {
@@ -654,5 +697,5 @@
 	}
 
-	serv_join_chat(purple_account_get_connection(pa), chat_hash);
+	serv_join_chat(purple_account_get_connection(pd->account), chat_hash);
 
 	return NULL;
@@ -981,5 +1024,4 @@
 		pqad->yes(pqad->user_data, pqad->yes_i);
 	}
-	g_free(pqad);
 }
 
@@ -991,5 +1033,13 @@
 		pqad->no(pqad->user_data, pqad->no_i);
 	}
-	g_free(pqad);
+}
+
+/* q->free() callback from query_del()*/
+static void prplcb_request_action_free(void *data)
+{
+	struct prplcb_request_action_data *pqad = data;
+
+	pqad->bee_data = NULL;
+	purple_request_close(PURPLE_REQUEST_ACTION, pqad);
 }
 
@@ -1026,5 +1076,6 @@
 	q = g_strdup_printf("Request: %s\n\n%s\n\n%s", title, primary, secondary);
 	pqad->bee_data = query_add(local_bee->ui_data, purple_ic_by_pa(account), q,
-	                           prplcb_request_action_yes, prplcb_request_action_no, g_free, pqad);
+	                           prplcb_request_action_yes, prplcb_request_action_no,
+	                           prplcb_request_action_free, pqad);
 
 	g_free(q);
@@ -1033,19 +1084,89 @@
 }
 
-/*
-static void prplcb_request_test()
-{
-        fprintf( stderr, "bla\n" );
-}
-*/
+/* So it turns out some requests have no account context at all, because
+ * libpurple hates us. This means that query_del_by_conn() won't remove those
+ * on logout, and will segfault if the user replies. That's why this exists.
+ */
+static void prplcb_close_request(PurpleRequestType type, void *data)
+{
+	struct prplcb_request_action_data *pqad;
+	struct request_input_data *ri;
+	struct purple_data *pd;
+
+	if (!data) {
+		return;
+	}
+
+	switch (type) {
+	case PURPLE_REQUEST_ACTION:
+		pqad = data;
+		/* if this is null, it's because query_del was run already */
+		if (pqad->bee_data) {
+			query_del(local_bee->ui_data, pqad->bee_data);
+		}
+		g_free(pqad);
+		break;
+	case PURPLE_REQUEST_INPUT:
+		ri = data;
+		pd = ri->ic->proto_data;
+		imcb_remove_buddy(ri->ic, ri->buddy, NULL);
+		g_free(ri->buddy);
+		g_hash_table_remove(pd->input_requests, GUINT_TO_POINTER(ri->id));
+		break;
+	default:
+		g_free(data);
+		break;
+	}
+
+}
+
+void* prplcb_request_input(const char *title, const char *primary,
+        const char *secondary, const char *default_value, gboolean multiline,
+        gboolean masked, gchar *hint, const char *ok_text, GCallback ok_cb,
+        const char *cancel_text, GCallback cancel_cb, PurpleAccount *account,
+        const char *who, PurpleConversation *conv, void *user_data)
+{
+	struct im_connection *ic = purple_ic_by_pa(account);
+	struct purple_data *pd = ic->proto_data;
+	struct request_input_data *ri = g_new0(struct request_input_data, 1);
+	guint id = pd->next_request_id++;
+
+	ri->id = id;
+	ri->ic = ic;
+	ri->buddy = g_strdup_printf("%s_%u", PURPLE_REQUEST_HANDLE, id);
+	ri->data_callback = (ri_callback_t) ok_cb;
+	ri->user_data = user_data;
+	g_hash_table_insert(pd->input_requests, GUINT_TO_POINTER(id), ri);
+
+	imcb_add_buddy(ic, ri->buddy, NULL);
+	imcb_buddy_msg(ic, ri->buddy, secondary, 0, 0);
+
+	return ri;
+}
+
+void purple_request_input_callback(guint id, struct im_connection *ic,
+                                   const char *message, const char *who)
+{
+	struct purple_data *pd = ic->proto_data;
+	struct request_input_data *ri;
+
+	if (!(ri = g_hash_table_lookup(pd->input_requests, GUINT_TO_POINTER(id)))) {
+		return;
+	}
+
+	ri->data_callback(ri->user_data, message);
+
+	purple_request_close(PURPLE_REQUEST_INPUT, ri);
+}
+
 
 static PurpleRequestUiOps bee_request_uiops =
 {
-	NULL,
+	prplcb_request_input,
 	NULL,
 	prplcb_request_action,
 	NULL,
 	NULL,
-	NULL,
+	prplcb_close_request,
 	NULL,
 };
Index: protocols/skype/Makefile
===================================================================
--- protocols/skype/Makefile	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/skype/Makefile	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -6,7 +6,7 @@
 DATE := $(shell date +%Y-%m-%d)
 INSTALL = install
-ASCIIDOC = yes
 
-ifeq ($(ASCIIDOC),yes)
+
+ifdef ASCIIDOC
 MANPAGES = skyped.1
 else
@@ -29,5 +29,5 @@
 
 install-doc: doc
-ifeq ($(ASCIIDOC),yes)
+ifdef ASCIIDOC
 	$(INSTALL) -d $(DESTDIR)$(MANDIR)/man1
 	$(INSTALL) -m644 $(MANPAGES) $(DESTDIR)$(MANDIR)/man1
Index: protocols/twitter/twitter.c
===================================================================
--- protocols/twitter/twitter.c	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/twitter/twitter.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -852,4 +852,21 @@
 }
 
+/* Parses a decimal or hex tweet ID, returns TRUE on success */
+static gboolean twitter_parse_id(char *string, int base, guint64 *id)
+{
+	guint64 parsed;
+	char *endptr;
+
+	errno = 0;
+	parsed = g_ascii_strtoull(string, &endptr, base);
+	if (errno || endptr == string || *endptr != '\0') {
+		return FALSE;
+	}
+	*id = parsed;
+	return TRUE;
+}
+
+bee_user_t twitter_log_local_user;
+
 /** Convert the given bitlbee tweet ID, bitlbee username, or twitter tweet ID
  *  into a twitter tweet ID.
@@ -879,13 +896,8 @@
 			arg++;
 		}
-		if (sscanf(arg, "%" G_GINT64_MODIFIER "x", &id) == 1 &&
-		    id < TWITTER_LOG_LENGTH) {
+		if (twitter_parse_id(arg, 16, &id) && id < TWITTER_LOG_LENGTH) {
 			bu = td->log[id].bu;
 			id = td->log[id].id;
-			/* Beware of dangling pointers! */
-			if (!g_slist_find(ic->bee->users, bu)) {
-				bu = NULL;
-			}
-		} else if (sscanf(arg, "%" G_GINT64_MODIFIER "d", &id) == 1) {
+		} else if (twitter_parse_id(arg, 10, &id)) {
 			/* Allow normal tweet IDs as well; not a very useful
 			   feature but it's always been there. Just ignore
@@ -897,4 +909,14 @@
 	}
 	if (bu_) {
+		if (bu == &twitter_log_local_user) {
+			/* HACK alert. There's no bee_user object for the local
+			 * user so just fake one for the few cmds that need it. */
+			twitter_log_local_user.handle = td->user;
+		} else {
+			/* Beware of dangling pointers! */
+			if (!g_slist_find(ic->bee->users, bu)) {
+				bu = NULL;
+			}
+		}
 		*bu_ = bu;
 	}
@@ -989,4 +1011,17 @@
 		in_reply_to = id;
 		allow_post = TRUE;
+	} else if (g_strcasecmp(cmd[0], "url") == 0) {
+		id = twitter_message_id_from_command_arg(ic, cmd[1], &bu);
+		if (!id) {
+			twitter_log(ic, "Tweet `%s' does not exist", cmd[1]);
+		} else {
+			/* More common link is twitter.com/$UID/status/$ID (and that's
+			 * what this will 302 to) but can't generate that since for RTs,
+			 * bu here points at the retweeter while id contains the id of
+			 * the original message. */
+			twitter_log(ic, "https://twitter.com/statuses/%lld", id);
+		}
+		goto eof;
+
 	} else if (g_strcasecmp(cmd[0], "post") == 0) {
 		message += 5;
Index: protocols/twitter/twitter.h
===================================================================
--- protocols/twitter/twitter.h	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/twitter/twitter.h	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -101,5 +101,7 @@
 struct twitter_log_data {
 	guint64 id;
-	struct bee_user *bu; /* DANGER: can be a dead pointer. Check it first. */
+	/* DANGER: bu can be a dead pointer. Check it first.
+	 * twitter_message_id_from_command_arg() will do this. */
+	struct bee_user *bu;
 };
 
@@ -110,4 +112,12 @@
  */
 extern GSList *twitter_connections;
+
+/**
+ * Evil hack: Fake bee_user which will always point at the local user.
+ * Sometimes used as a return value by twitter_message_id_from_command_arg.
+ * NOT thread safe but don't you dare to even think of ever making BitlBee
+ * threaded. :-)
+ */
+extern bee_user_t twitter_log_local_user;
 
 void twitter_login_finish(struct im_connection *ic);
Index: protocols/twitter/twitter_lib.c
===================================================================
--- protocols/twitter/twitter_lib.c	(revision 531eabdee2ee9d64e034bbb82caa08a69dd8dc9c)
+++ protocols/twitter/twitter_lib.c	(revision 8563fe7ae580368212233d53e9b81b67dfa7b619)
@@ -460,5 +460,5 @@
 #endif
 
-static char* expand_entities(char* text, const json_value *entities);
+static void expand_entities(char **text, const json_value *node);
 
 /**
@@ -473,5 +473,5 @@
 {
 	struct twitter_xml_status *txs;
-	const json_value *rt = NULL, *entities = NULL;
+	const json_value *rt = NULL;
 
 	if (node->type != json_object) {
@@ -501,6 +501,4 @@
 		} else if (strcmp("in_reply_to_status_id", k) == 0 && v->type == json_integer) {
 			txs->reply_to = v->u.integer;
-		} else if (strcmp("entities", k) == 0 && v->type == json_object) {
-			entities = v;
 		}
 	}
@@ -516,6 +514,6 @@
 			txs_free(rtxs);
 		}
-	} else if (entities) {
-		txs->text = expand_entities(txs->text, entities);
+	} else {
+		expand_entities(&txs->text, node);
 	}
 
@@ -534,5 +532,4 @@
 {
 	struct twitter_xml_status *txs;
-	const json_value *entities = NULL;
 
 	if (node->type != json_object) {
@@ -561,7 +558,5 @@
 	}
 
-	if (entities) {
-		txs->text = expand_entities(txs->text, entities);
-	}
+	expand_entities(&txs->text, node);
 
 	if (txs->text && txs->user && txs->id) {
@@ -573,6 +568,24 @@
 }
 
-static char* expand_entities(char* text, const json_value *entities)
-{
+static void expand_entities(char **text, const json_value *node)
+{
+	json_value *entities, *quoted;
+	char *quote_url = NULL, *quote_text = NULL;
+
+	if (!((entities = json_o_get(node, "entities")) && entities->type == json_object))
+		return;
+	if ((quoted = json_o_get(node, "quoted_status")) && quoted->type == json_object) {
+		/* New "retweets with comments" feature. Note that this info
+		 * seems to be included in the streaming API only! Grab the
+		 * full message and try to insert it when we run into the
+		 * Tweet entity. */
+		struct twitter_xml_status *txs = twitter_xt_get_status(quoted);
+		quote_text = g_strdup_printf("@%s: %s", txs->user->screen_name, txs->text);
+		quote_url = g_strdup_printf("%s/status/%" G_GUINT64_FORMAT, txs->user->screen_name, txs->id);
+		txs_free(txs);
+	} else {
+		quoted = NULL;
+	}
+
 	JSON_O_FOREACH(entities, k, v) {
 		int i;
@@ -586,4 +599,6 @@
 
 		for (i = 0; i < v->u.array.length; i++) {
+			const char *format = "%s%s <%s>%s";
+
 			if (v->u.array.values[i]->type != json_object) {
 				continue;
@@ -592,20 +607,25 @@
 			const char *kort = json_o_str(v->u.array.values[i], "url");
 			const char *disp = json_o_str(v->u.array.values[i], "display_url");
+			const char *full = json_o_str(v->u.array.values[i], "expanded_url");
 			char *pos, *new;
 
-			if (!kort || !disp || !(pos = strstr(text, kort))) {
+			if (!kort || !disp || !(pos = strstr(*text, kort))) {
 				continue;
 			}
+			if (quote_url && strstr(full, quote_url)) {
+				format = "%s<%s> [%s]%s";
+				disp = quote_text;
+			}
 
 			*pos = '\0';
-			new = g_strdup_printf("%s%s <%s>%s", text, kort,
+			new = g_strdup_printf(format, *text, kort,
 			                      disp, pos + strlen(kort));
 
-			g_free(text);
-			text = new;
-		}
-	}
-
-	return text;
+			g_free(*text);
+			*text = new;
+		}
+	}
+	g_free(quote_text);
+	g_free(quote_url);
 }
 
@@ -681,4 +701,6 @@
 	if (g_strcasecmp(txs->user->screen_name, td->user) == 0) {
 		td->log[td->log_id].id = txs->rt_id;
+		/* More useful than NULL. */
+		td->log[td->log_id].bu = &twitter_log_local_user;
 	}
 
@@ -832,5 +854,5 @@
 
 	last_id_str = g_strdup_printf("%" G_GUINT64_FORMAT, td->timeline_id);
-	set_setstr(&ic->acc->set, "last_tweet", last_id_str);
+	set_setstr(&ic->acc->set, "_last_tweet", last_id_str);
 	g_free(last_id_str);
 }
@@ -862,4 +884,7 @@
 
 		imcb_error(ic, "Stream closed (%s)", req->status_string);
+		if (req->status_code == 401) {
+			imcb_error(ic, "Check your system clock.");
+		}
 		imc_logout(ic, TRUE);
 		return;
